<script>
import axios from 'axios'

// import { BBadge, BTable } from 'bootstrap-vue'
// import SettingsTemplate from '@/components/settings/SettingsTemplate.vue'
import IntegrationDeleteModal from '@/components/inventory/IntegrationDeleteModal'

export default {
  name: 'IntegrationsList',
  components: {
    SettingsTemplate,
    IntegrationDeleteModal,
    BTable,
    BBadge,
  },
  data() {
    return {
      fields: [
        { key: 'id', label: 'ID' },
        { key: 'name', label: 'Connector Name' },
        { key: 'type', label: 'Integration Type' },
        { key: 'category', label: 'Category' },
        { key: 'status', label: 'Status' },
        { key: 'update_date', label: 'Update date' },
        { key: 'actions', label: 'Actions' },
      ],
      integrationsList: [],
      statusIcons: {
        unknown: { text: 'unknown', color: 'warning', name: 'HelpCircleIcon' },
        pending: { text: 'pending', color: 'primary', name: 'ClockIcon' },
        success: { text: 'success', color: 'success', name: 'CheckCircleIcon' },
        failed: { text: 'failed', color: 'danger', name: 'XCircleIcon' },
      },
    }
  },
  mounted() {
    this.getIntegrations()
  },
  methods: {
    async getIntegrations() {
      try {
        const response = await axios.get('http://localhost:8094/integrations')

        console.log('response: ', response)
        console.log('response.data: ', response.data)
        this.integrationsList = response.data
      }
      catch (error) {
        console.error('Error getting integrations', error)
      }
    },
  },
}
</script>

<template>
  <SettingsTemplate>
    <div class="m-2">
      <BTable
        striped
        hover
        responsive
        :fields="fields"
        :items="integrationsList"
      >
        <template #cell(status)="data">
          <!--
            feather-icon
            :icon="statusIcons[data.item.status].name"
            :class="'text-'+statusIcons[data.item.status].color"
            size="16"
            /
          -->
          <BBadge
            pill
            :variant="statusIcons[data.item.status].color"
          >
            {{ statusIcons[data.item.status].text }}
          </BBadge>
        </template>

        <template #cell(actions)="data">
          <IntegrationDeleteModal
            :user-id="data.item.id"
            :username="data.item.username"
            @finished="finished"
          />
        </template>
      </BTable>
    </div>
  </SettingsTemplate>
</template>
